//=========================================
// will alert if BarRun previous 
// COMPLETED candles are all down 
// or all up
// AND
// difference between high and low
// is PipWidth pips
//=========================================

#property copyright "canonseer"
#property link      ""

extern int BarRun = 3;
extern int PipWidth = 10;

int init()
{
   return(0);
}

int deinit()
{
   return(0);
}
int ArrID = 0;
int start()
{
   if (!NewBar()) return(0);
   if(CheckUp())
   {
      ObjectCreate(DoubleToStr(ArrID,1),OBJ_ARROW,0,iTime(NULL,0,0),Bid);
      ObjectSet(DoubleToStr(ArrID,1),OBJPROP_COLOR,Green); //green for long. duh.
      ArrID++;
      PlaySound("alert.wav");
   }
   if(CheckDown())
   {
      ObjectCreate(DoubleToStr(ArrID,1),OBJ_ARROW,0,iTime(NULL,0,0),Bid);
      ArrID++;
      PlaySound("alert.wav");
   }
   return(0);
}
bool CheckUp()
{
   double high = High[1];
   double low = Low[1];
   for (int i = 1; i < BarRun+1; i++)
   {
      //update high and low
      if (High[i] > high) high = High[i];
      if (Low[i] < low) low = Low[i];
      
      //check for up candle
      if (Open[i] > Close[i]) return(false); //down candle, not a run
   }
   double true_width = (high-low)*10000;
   return(true_width>=PipWidth);
}
bool CheckDown()
{
   double high = High[1];
   double low = Low[1];
   for (int i = 1; i < BarRun+1; i++)
   {
      //update high and low
      if (High[i] > high) high = High[i];
      if (Low[i] < low) low = Low[i];
      
      //check for down candle
      if (Open[i] < Close[i]) return(false); //up candle, not a run
   }
   double true_width = (high-low)*10000;
   return(true_width>=PipWidth);
}
datetime PrevTime = 0;
datetime CurrTime = 0;
bool NewBar() {
   CurrTime = iTime(NULL,0,1);
   if (CurrTime==PrevTime) return(false);
   PrevTime = CurrTime;
   return(true);
}